<?php
/**
 * InlineResponse20146ContentContentSupport
 *
 * PHP version 7.3
 *
 * @category Class
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * TANSS API
 *
 * ## Documentation of the TANSS API. Version: 5.8.22.1  ### older versions Older versions of the API documentation can be found here: * [Docs for 5.8.21.6](https://api-doc.tanss.de/5.8.21.6/) * [Docs for 5.8.21.3](https://api-doc.tanss.de/5.8.21.3/) * [Docs for 5.8.21.1](https://api-doc.tanss.de/5.8.21.1/) * [Docs for 5.8.20.5](https://api-doc.tanss.de/5.8.20.5/) * [Docs for 5.8.20.4](https://api-doc.tanss.de/5.8.20.4/) * [Docs for 5.8.20.2](https://api-doc.tanss.de/5.8.20.2/) * [Docs for 5.8.19.3](https://api-doc.tanss.de/5.8.19.3/)
 *
 * The version of the OpenAPI document: 5.8.22.1
 * Contact: support@tanss.de
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 6.0.0-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace SLIS\Adapter\Tanss\Model;

use \ArrayAccess;
use \SLIS\Adapter\Tanss\ObjectSerializer;

/**
 * InlineResponse20146ContentContentSupport Class Doc Comment
 *
 * @category Class
 * @description if the tanss ticket object contains infos about a support, then the infos are given here
 * @package  SLIS\Adapter\Tanss
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 * @implements \ArrayAccess<TKey, TValue>
 * @template TKey int|null
 * @template TValue mixed|null
 */
class InlineResponse20146ContentContentSupport implements ModelInterface, ArrayAccess, \JsonSerializable
{
    public const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'inline_response_201_46_content_content_support';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'companyId' => 'int',
        'companyName' => 'string',
        'employeeId' => 'int',
        'employeeName' => 'string',
        'location' => 'string',
        'date' => 'int',
        'dateFormatted' => 'string',
        'duration' => 'int',
        'typeId' => 'int',
        'typeName' => 'string',
        'text' => 'string',
        'internal' => 'bool',
        'planningType' => 'object',
        'planningTypeName' => 'string',
        'outlook' => 'bool'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      * @phpstan-var array<string, string|null>
      * @psalm-var array<string, string|null>
      */
    protected static $openAPIFormats = [
        'id' => null,
        'companyId' => null,
        'companyName' => null,
        'employeeId' => null,
        'employeeName' => null,
        'location' => null,
        'date' => 'timestamp',
        'dateFormatted' => null,
        'duration' => null,
        'typeId' => null,
        'typeName' => null,
        'text' => null,
        'internal' => null,
        'planningType' => null,
        'planningTypeName' => null,
        'outlook' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'companyId' => 'companyId',
        'companyName' => 'companyName',
        'employeeId' => 'employeeId',
        'employeeName' => 'employeeName',
        'location' => 'location',
        'date' => 'date',
        'dateFormatted' => 'dateFormatted',
        'duration' => 'duration',
        'typeId' => 'typeId',
        'typeName' => 'typeName',
        'text' => 'text',
        'internal' => 'internal',
        'planningType' => 'planningType',
        'planningTypeName' => 'planningTypeName',
        'outlook' => 'outlook'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'companyId' => 'setCompanyId',
        'companyName' => 'setCompanyName',
        'employeeId' => 'setEmployeeId',
        'employeeName' => 'setEmployeeName',
        'location' => 'setLocation',
        'date' => 'setDate',
        'dateFormatted' => 'setDateFormatted',
        'duration' => 'setDuration',
        'typeId' => 'setTypeId',
        'typeName' => 'setTypeName',
        'text' => 'setText',
        'internal' => 'setInternal',
        'planningType' => 'setPlanningType',
        'planningTypeName' => 'setPlanningTypeName',
        'outlook' => 'setOutlook'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'companyId' => 'getCompanyId',
        'companyName' => 'getCompanyName',
        'employeeId' => 'getEmployeeId',
        'employeeName' => 'getEmployeeName',
        'location' => 'getLocation',
        'date' => 'getDate',
        'dateFormatted' => 'getDateFormatted',
        'duration' => 'getDuration',
        'typeId' => 'getTypeId',
        'typeName' => 'getTypeName',
        'text' => 'getText',
        'internal' => 'getInternal',
        'planningType' => 'getPlanningType',
        'planningTypeName' => 'getPlanningTypeName',
        'outlook' => 'getOutlook'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    public const LOCATION_OFFICE = 'OFFICE';
    public const LOCATION_CUSTOMER = 'CUSTOMER';
    public const LOCATION_REMOTE = 'REMOTE';

    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getLocationAllowableValues()
    {
        return [
            self::LOCATION_OFFICE,
            self::LOCATION_CUSTOMER,
            self::LOCATION_REMOTE,
        ];
    }

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['id'] = $data['id'] ?? null;
        $this->container['companyId'] = $data['companyId'] ?? null;
        $this->container['companyName'] = $data['companyName'] ?? null;
        $this->container['employeeId'] = $data['employeeId'] ?? null;
        $this->container['employeeName'] = $data['employeeName'] ?? null;
        $this->container['location'] = $data['location'] ?? null;
        $this->container['date'] = $data['date'] ?? null;
        $this->container['dateFormatted'] = $data['dateFormatted'] ?? null;
        $this->container['duration'] = $data['duration'] ?? null;
        $this->container['typeId'] = $data['typeId'] ?? null;
        $this->container['typeName'] = $data['typeName'] ?? null;
        $this->container['text'] = $data['text'] ?? null;
        $this->container['internal'] = $data['internal'] ?? null;
        $this->container['planningType'] = $data['planningType'] ?? null;
        $this->container['planningTypeName'] = $data['planningTypeName'] ?? null;
        $this->container['outlook'] = $data['outlook'] ?? null;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        $allowedValues = $this->getLocationAllowableValues();
        if (!is_null($this->container['location']) && !in_array($this->container['location'], $allowedValues, true)) {
            $invalidProperties[] = sprintf(
                "invalid value '%s' for 'location', must be one of '%s'",
                $this->container['location'],
                implode("', '", $allowedValues)
            );
        }

        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int|null
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int|null $id id of the support
     *
     * @return self
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets companyId
     *
     * @return int|null
     */
    public function getCompanyId()
    {
        return $this->container['companyId'];
    }

    /**
     * Sets companyId
     *
     * @param int|null $companyId id of the company
     *
     * @return self
     */
    public function setCompanyId($companyId)
    {
        $this->container['companyId'] = $companyId;

        return $this;
    }

    /**
     * Gets companyName
     *
     * @return string|null
     */
    public function getCompanyName()
    {
        return $this->container['companyName'];
    }

    /**
     * Sets companyName
     *
     * @param string|null $companyName name of the company
     *
     * @return self
     */
    public function setCompanyName($companyName)
    {
        $this->container['companyName'] = $companyName;

        return $this;
    }

    /**
     * Gets employeeId
     *
     * @return int|null
     */
    public function getEmployeeId()
    {
        return $this->container['employeeId'];
    }

    /**
     * Sets employeeId
     *
     * @param int|null $employeeId id of the technician
     *
     * @return self
     */
    public function setEmployeeId($employeeId)
    {
        $this->container['employeeId'] = $employeeId;

        return $this;
    }

    /**
     * Gets employeeName
     *
     * @return string|null
     */
    public function getEmployeeName()
    {
        return $this->container['employeeName'];
    }

    /**
     * Sets employeeName
     *
     * @param string|null $employeeName name of the technician
     *
     * @return self
     */
    public function setEmployeeName($employeeName)
    {
        $this->container['employeeName'] = $employeeName;

        return $this;
    }

    /**
     * Gets location
     *
     * @return string|null
     */
    public function getLocation()
    {
        return $this->container['location'];
    }

    /**
     * Sets location
     *
     * @param string|null $location Defines, where a support takes place
     *
     * @return self
     */
    public function setLocation($location)
    {
        $allowedValues = $this->getLocationAllowableValues();
        if (!is_null($location) && !in_array($location, $allowedValues, true)) {
            throw new \InvalidArgumentException(
                sprintf(
                    "Invalid value '%s' for 'location', must be one of '%s'",
                    $location,
                    implode("', '", $allowedValues)
                )
            );
        }
        $this->container['location'] = $location;

        return $this;
    }

    /**
     * Gets date
     *
     * @return int|null
     */
    public function getDate()
    {
        return $this->container['date'];
    }

    /**
     * Sets date
     *
     * @param int|null $date date of the support as timestamp
     *
     * @return self
     */
    public function setDate($date)
    {
        $this->container['date'] = $date;

        return $this;
    }

    /**
     * Gets dateFormatted
     *
     * @return string|null
     */
    public function getDateFormatted()
    {
        return $this->container['dateFormatted'];
    }

    /**
     * Sets dateFormatted
     *
     * @param string|null $dateFormatted formatted date of the support
     *
     * @return self
     */
    public function setDateFormatted($dateFormatted)
    {
        $this->container['dateFormatted'] = $dateFormatted;

        return $this;
    }

    /**
     * Gets duration
     *
     * @return int|null
     */
    public function getDuration()
    {
        return $this->container['duration'];
    }

    /**
     * Sets duration
     *
     * @param int|null $duration duration in minutes
     *
     * @return self
     */
    public function setDuration($duration)
    {
        $this->container['duration'] = $duration;

        return $this;
    }

    /**
     * Gets typeId
     *
     * @return int|null
     */
    public function getTypeId()
    {
        return $this->container['typeId'];
    }

    /**
     * Sets typeId
     *
     * @param int|null $typeId id of the support type
     *
     * @return self
     */
    public function setTypeId($typeId)
    {
        $this->container['typeId'] = $typeId;

        return $this;
    }

    /**
     * Gets typeName
     *
     * @return string|null
     */
    public function getTypeName()
    {
        return $this->container['typeName'];
    }

    /**
     * Sets typeName
     *
     * @param string|null $typeName name of the support type
     *
     * @return self
     */
    public function setTypeName($typeName)
    {
        $this->container['typeName'] = $typeName;

        return $this;
    }

    /**
     * Gets text
     *
     * @return string|null
     */
    public function getText()
    {
        return $this->container['text'];
    }

    /**
     * Sets text
     *
     * @param string|null $text text(description of the support
     *
     * @return self
     */
    public function setText($text)
    {
        $this->container['text'] = $text;

        return $this;
    }

    /**
     * Gets internal
     *
     * @return bool|null
     */
    public function getInternal()
    {
        return $this->container['internal'];
    }

    /**
     * Sets internal
     *
     * @param bool|null $internal true if it's an internal support
     *
     * @return self
     */
    public function setInternal($internal)
    {
        $this->container['internal'] = $internal;

        return $this;
    }

    /**
     * Gets planningType
     *
     * @return object|null
     */
    public function getPlanningType()
    {
        return $this->container['planningType'];
    }

    /**
     * Sets planningType
     *
     * @param object|null $planningType planningType
     *
     * @return self
     */
    public function setPlanningType($planningType)
    {
        $this->container['planningType'] = $planningType;

        return $this;
    }

    /**
     * Gets planningTypeName
     *
     * @return string|null
     */
    public function getPlanningTypeName()
    {
        return $this->container['planningTypeName'];
    }

    /**
     * Sets planningTypeName
     *
     * @param string|null $planningTypeName name of the planning typ (i.e. \"Getätigte Leistung\", \"Termin\")
     *
     * @return self
     */
    public function setPlanningTypeName($planningTypeName)
    {
        $this->container['planningTypeName'] = $planningTypeName;

        return $this;
    }

    /**
     * Gets outlook
     *
     * @return bool|null
     */
    public function getOutlook()
    {
        return $this->container['outlook'];
    }

    /**
     * Sets outlook
     *
     * @param bool|null $outlook true if it's an outlook appointment
     *
     * @return self
     */
    public function setOutlook($outlook)
    {
        $this->container['outlook'] = $outlook;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed|null
     */
    #[\ReturnTypeWillChange]
    public function offsetGet($offset)
    {
        return $this->container[$offset] ?? null;
    }

    /**
     * Sets value based on offset.
     *
     * @param int|null $offset Offset
     * @param mixed    $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Serializes the object to a value that can be serialized natively by json_encode().
     * @link https://www.php.net/manual/en/jsonserializable.jsonserialize.php
     *
     * @return mixed Returns data which can be serialized by json_encode(), which is a value
     * of any type other than a resource.
     */
    #[\ReturnTypeWillChange]
    public function jsonSerialize()
    {
       return ObjectSerializer::sanitizeForSerialization($this);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


